/*
 functions for communication between pic and host - via usb, rs232 or both

 $Id: io.h,v 1.3 2019/07/07 10:34:45 daeb Exp $
*/
/*

 Copyright (C) 2019 Bernhard Dubler ( klappe@daeublers.de )

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef _IO_H_INCLUDED
#include "def.h"

#ifdef USEUSB
void service_io(void);
#else
#define service_io() ((void)0)
#endif

char getchar(void);
void putchar(char ch);
void putstr(const char *s);
int testchar(void);
void print64(unsigned long h, unsigned long l, int8_t mindigits);
void print16(unsigned l, int8_t mindigits);
#ifdef DEBUGRFID
void print32(unsigned long l, int8_t mindigits);
void printhex(unsigned long l, int8_t mindigits);
#endif

#define _IO_H_INCLUDED
#endif
