/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.65.2
        Device            :  PIC16F1459
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.45
        MPLAB 	          :  MPLAB X 4.15	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set RA0 procedures
#define RA0_GetValue()              PORTAbits.RA0

// get/set RA1 procedures
#define RA1_GetValue()              PORTAbits.RA1

// get/set SenClosed aliases
#define SenClosed_TRIS                 TRISAbits.TRISA4
#define SenClosed_LAT                  LATAbits.LATA4
#define SenClosed_PORT                 PORTAbits.RA4
#define SenClosed_WPU                  WPUAbits.WPUA4
#define SenClosed_ANS                  ANSELAbits.ANSA4
#define SenClosed_SetHigh()            do { LATAbits.LATA4 = 1; } while(0)
#define SenClosed_SetLow()             do { LATAbits.LATA4 = 0; } while(0)
#define SenClosed_Toggle()             do { LATAbits.LATA4 = ~LATAbits.LATA4; } while(0)
#define SenClosed_GetValue()           PORTAbits.RA4
#define SenClosed_SetDigitalInput()    do { TRISAbits.TRISA4 = 1; } while(0)
#define SenClosed_SetDigitalOutput()   do { TRISAbits.TRISA4 = 0; } while(0)
#define SenClosed_SetPullup()          do { WPUAbits.WPUA4 = 1; } while(0)
#define SenClosed_ResetPullup()        do { WPUAbits.WPUA4 = 0; } while(0)
#define SenClosed_SetAnalogMode()      do { ANSELAbits.ANSA4 = 1; } while(0)
#define SenClosed_SetDigitalMode()     do { ANSELAbits.ANSA4 = 0; } while(0)

// get/set LED_Heart aliases
#define LED_Heart_TRIS                 TRISAbits.TRISA5
#define LED_Heart_LAT                  LATAbits.LATA5
#define LED_Heart_PORT                 PORTAbits.RA5
#define LED_Heart_WPU                  WPUAbits.WPUA5
#define LED_Heart_SetHigh()            do { LATAbits.LATA5 = 1; } while(0)
#define LED_Heart_SetLow()             do { LATAbits.LATA5 = 0; } while(0)
#define LED_Heart_Toggle()             do { LATAbits.LATA5 = ~LATAbits.LATA5; } while(0)
#define LED_Heart_GetValue()           PORTAbits.RA5
#define LED_Heart_SetDigitalInput()    do { TRISAbits.TRISA5 = 1; } while(0)
#define LED_Heart_SetDigitalOutput()   do { TRISAbits.TRISA5 = 0; } while(0)
#define LED_Heart_SetPullup()          do { WPUAbits.WPUA5 = 1; } while(0)
#define LED_Heart_ResetPullup()        do { WPUAbits.WPUA5 = 0; } while(0)

// get/set MotDown aliases
#define MotDown_TRIS                 TRISBbits.TRISB4
#define MotDown_LAT                  LATBbits.LATB4
#define MotDown_PORT                 PORTBbits.RB4
#define MotDown_WPU                  WPUBbits.WPUB4
#define MotDown_ANS                  ANSELBbits.ANSB4
#define MotDown_SetHigh()            do { LATBbits.LATB4 = 1; } while(0)
#define MotDown_SetLow()             do { LATBbits.LATB4 = 0; } while(0)
#define MotDown_Toggle()             do { LATBbits.LATB4 = ~LATBbits.LATB4; } while(0)
#define MotDown_GetValue()           PORTBbits.RB4
#define MotDown_SetDigitalInput()    do { TRISBbits.TRISB4 = 1; } while(0)
#define MotDown_SetDigitalOutput()   do { TRISBbits.TRISB4 = 0; } while(0)
#define MotDown_SetPullup()          do { WPUBbits.WPUB4 = 1; } while(0)
#define MotDown_ResetPullup()        do { WPUBbits.WPUB4 = 0; } while(0)
#define MotDown_SetAnalogMode()      do { ANSELBbits.ANSB4 = 1; } while(0)
#define MotDown_SetDigitalMode()     do { ANSELBbits.ANSB4 = 0; } while(0)

// get/set MotEnable aliases
#define MotEnable_TRIS                 TRISBbits.TRISB5
#define MotEnable_LAT                  LATBbits.LATB5
#define MotEnable_PORT                 PORTBbits.RB5
#define MotEnable_WPU                  WPUBbits.WPUB5
#define MotEnable_ANS                  ANSELBbits.ANSB5
#define MotEnable_SetHigh()            do { LATBbits.LATB5 = 1; } while(0)
#define MotEnable_SetLow()             do { LATBbits.LATB5 = 0; } while(0)
#define MotEnable_Toggle()             do { LATBbits.LATB5 = ~LATBbits.LATB5; } while(0)
#define MotEnable_GetValue()           PORTBbits.RB5
#define MotEnable_SetDigitalInput()    do { TRISBbits.TRISB5 = 1; } while(0)
#define MotEnable_SetDigitalOutput()   do { TRISBbits.TRISB5 = 0; } while(0)
#define MotEnable_SetPullup()          do { WPUBbits.WPUB5 = 1; } while(0)
#define MotEnable_ResetPullup()        do { WPUBbits.WPUB5 = 0; } while(0)
#define MotEnable_SetAnalogMode()      do { ANSELBbits.ANSB5 = 1; } while(0)
#define MotEnable_SetDigitalMode()     do { ANSELBbits.ANSB5 = 0; } while(0)

// get/set SenOpened aliases
#define SenOpened_TRIS                 TRISBbits.TRISB6
#define SenOpened_LAT                  LATBbits.LATB6
#define SenOpened_PORT                 PORTBbits.RB6
#define SenOpened_WPU                  WPUBbits.WPUB6
#define SenOpened_SetHigh()            do { LATBbits.LATB6 = 1; } while(0)
#define SenOpened_SetLow()             do { LATBbits.LATB6 = 0; } while(0)
#define SenOpened_Toggle()             do { LATBbits.LATB6 = ~LATBbits.LATB6; } while(0)
#define SenOpened_GetValue()           PORTBbits.RB6
#define SenOpened_SetDigitalInput()    do { TRISBbits.TRISB6 = 1; } while(0)
#define SenOpened_SetDigitalOutput()   do { TRISBbits.TRISB6 = 0; } while(0)
#define SenOpened_SetPullup()          do { WPUBbits.WPUB6 = 1; } while(0)
#define SenOpened_ResetPullup()        do { WPUBbits.WPUB6 = 0; } while(0)

// get/set SenMotion aliases
#define SenMotion_TRIS                 TRISBbits.TRISB7
#define SenMotion_LAT                  LATBbits.LATB7
#define SenMotion_PORT                 PORTBbits.RB7
#define SenMotion_WPU                  WPUBbits.WPUB7
#define SenMotion_SetHigh()            do { LATBbits.LATB7 = 1; } while(0)
#define SenMotion_SetLow()             do { LATBbits.LATB7 = 0; } while(0)
#define SenMotion_Toggle()             do { LATBbits.LATB7 = ~LATBbits.LATB7; } while(0)
#define SenMotion_GetValue()           PORTBbits.RB7
#define SenMotion_SetDigitalInput()    do { TRISBbits.TRISB7 = 1; } while(0)
#define SenMotion_SetDigitalOutput()   do { TRISBbits.TRISB7 = 0; } while(0)
#define SenMotion_SetPullup()          do { WPUBbits.WPUB7 = 1; } while(0)
#define SenMotion_ResetPullup()        do { WPUBbits.WPUB7 = 0; } while(0)

// get/set MotUp aliases
#define MotUp_TRIS                 TRISCbits.TRISC1
#define MotUp_LAT                  LATCbits.LATC1
#define MotUp_PORT                 PORTCbits.RC1
#define MotUp_ANS                  ANSELCbits.ANSC1
#define MotUp_SetHigh()            do { LATCbits.LATC1 = 1; } while(0)
#define MotUp_SetLow()             do { LATCbits.LATC1 = 0; } while(0)
#define MotUp_Toggle()             do { LATCbits.LATC1 = ~LATCbits.LATC1; } while(0)
#define MotUp_GetValue()           PORTCbits.RC1
#define MotUp_SetDigitalInput()    do { TRISCbits.TRISC1 = 1; } while(0)
#define MotUp_SetDigitalOutput()   do { TRISCbits.TRISC1 = 0; } while(0)
#define MotUp_SetAnalogMode()      do { ANSELCbits.ANSC1 = 1; } while(0)
#define MotUp_SetDigitalMode()     do { ANSELCbits.ANSC1 = 0; } while(0)

// get/set Rfid aliases
#define Rfid_TRIS                 TRISCbits.TRISC2
#define Rfid_LAT                  LATCbits.LATC2
#define Rfid_PORT                 PORTCbits.RC2
#define Rfid_ANS                  ANSELCbits.ANSC2
#define Rfid_SetHigh()            do { LATCbits.LATC2 = 1; } while(0)
#define Rfid_SetLow()             do { LATCbits.LATC2 = 0; } while(0)
#define Rfid_Toggle()             do { LATCbits.LATC2 = ~LATCbits.LATC2; } while(0)
#define Rfid_GetValue()           PORTCbits.RC2
#define Rfid_SetDigitalInput()    do { TRISCbits.TRISC2 = 1; } while(0)
#define Rfid_SetDigitalOutput()   do { TRISCbits.TRISC2 = 0; } while(0)
#define Rfid_SetAnalogMode()      do { ANSELCbits.ANSC2 = 1; } while(0)
#define Rfid_SetDigitalMode()     do { ANSELCbits.ANSC2 = 0; } while(0)

// get/set Step2 aliases
#define Step2_TRIS                 TRISCbits.TRISC3
#define Step2_LAT                  LATCbits.LATC3
#define Step2_PORT                 PORTCbits.RC3
#define Step2_ANS                  ANSELCbits.ANSC3
#define Step2_SetHigh()            do { LATCbits.LATC3 = 1; } while(0)
#define Step2_SetLow()             do { LATCbits.LATC3 = 0; } while(0)
#define Step2_Toggle()             do { LATCbits.LATC3 = ~LATCbits.LATC3; } while(0)
#define Step2_GetValue()           PORTCbits.RC3
#define Step2_SetDigitalInput()    do { TRISCbits.TRISC3 = 1; } while(0)
#define Step2_SetDigitalOutput()   do { TRISCbits.TRISC3 = 0; } while(0)
#define Step2_SetAnalogMode()      do { ANSELCbits.ANSC3 = 1; } while(0)
#define Step2_SetDigitalMode()     do { ANSELCbits.ANSC3 = 0; } while(0)

// get/set Step1 aliases
#define Step1_TRIS                 TRISCbits.TRISC4
#define Step1_LAT                  LATCbits.LATC4
#define Step1_PORT                 PORTCbits.RC4
#define Step1_SetHigh()            do { LATCbits.LATC4 = 1; } while(0)
#define Step1_SetLow()             do { LATCbits.LATC4 = 0; } while(0)
#define Step1_Toggle()             do { LATCbits.LATC4 = ~LATCbits.LATC4; } while(0)
#define Step1_GetValue()           PORTCbits.RC4
#define Step1_SetDigitalInput()    do { TRISCbits.TRISC4 = 1; } while(0)
#define Step1_SetDigitalOutput()   do { TRISCbits.TRISC4 = 0; } while(0)

// get/set LED_InFrame aliases
#define LED_InFrame_TRIS                 TRISCbits.TRISC5
#define LED_InFrame_LAT                  LATCbits.LATC5
#define LED_InFrame_PORT                 PORTCbits.RC5
#define LED_InFrame_SetHigh()            do { LATCbits.LATC5 = 1; } while(0)
#define LED_InFrame_SetLow()             do { LATCbits.LATC5 = 0; } while(0)
#define LED_InFrame_Toggle()             do { LATCbits.LATC5 = ~LATCbits.LATC5; } while(0)
#define LED_InFrame_GetValue()           PORTCbits.RC5
#define LED_InFrame_SetDigitalInput()    do { TRISCbits.TRISC5 = 1; } while(0)
#define LED_InFrame_SetDigitalOutput()   do { TRISCbits.TRISC5 = 0; } while(0)

// get/set Step3 aliases
#define Step3_TRIS                 TRISCbits.TRISC6
#define Step3_LAT                  LATCbits.LATC6
#define Step3_PORT                 PORTCbits.RC6
#define Step3_ANS                  ANSELCbits.ANSC6
#define Step3_SetHigh()            do { LATCbits.LATC6 = 1; } while(0)
#define Step3_SetLow()             do { LATCbits.LATC6 = 0; } while(0)
#define Step3_Toggle()             do { LATCbits.LATC6 = ~LATCbits.LATC6; } while(0)
#define Step3_GetValue()           PORTCbits.RC6
#define Step3_SetDigitalInput()    do { TRISCbits.TRISC6 = 1; } while(0)
#define Step3_SetDigitalOutput()   do { TRISCbits.TRISC6 = 0; } while(0)
#define Step3_SetAnalogMode()      do { ANSELCbits.ANSC6 = 1; } while(0)
#define Step3_SetDigitalMode()     do { ANSELCbits.ANSC6 = 0; } while(0)

// get/set Step4 aliases
#define Step4_TRIS                 TRISCbits.TRISC7
#define Step4_LAT                  LATCbits.LATC7
#define Step4_PORT                 PORTCbits.RC7
#define Step4_ANS                  ANSELCbits.ANSC7
#define Step4_SetHigh()            do { LATCbits.LATC7 = 1; } while(0)
#define Step4_SetLow()             do { LATCbits.LATC7 = 0; } while(0)
#define Step4_Toggle()             do { LATCbits.LATC7 = ~LATCbits.LATC7; } while(0)
#define Step4_GetValue()           PORTCbits.RC7
#define Step4_SetDigitalInput()    do { TRISCbits.TRISC7 = 1; } while(0)
#define Step4_SetDigitalOutput()   do { TRISCbits.TRISC7 = 0; } while(0)
#define Step4_SetAnalogMode()      do { ANSELCbits.ANSC7 = 1; } while(0)
#define Step4_SetDigitalMode()     do { ANSELCbits.ANSC7 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/