/*
 count timer interrupts for time messurement
 implement uptime-clock

 $Id: time.c,v 1.4 2019/07/07 10:34:45 daeb Exp $
*/

/*

 Copyright (C) 2019 Bernhard Dubler ( klappe@daeublers.de )

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "mcc_generated_files/mcc.h"
#include "io.h"
#include "time.h"

#ifdef DEFTIME
static uint8_t s100=0;
static unsigned long s=0;
static unsigned days=0;
#endif

timetick_t now_timeticks=0;

static void time_irq(void)
{
#ifdef DEFTIME
	s100++;
	if (s100==100)
	{	s100=0;
		s++;
		if (s==(24*3600L)) s=0, days++;
	}
#endif
	now_timeticks++;
}

#ifdef DEFTIME
void print_time(void)
{	unsigned long nows;
	unsigned now100, min, h;

	INTERRUPT_GlobalInterruptDisable();
	nows=s;
	now100=s100;
	INTERRUPT_GlobalInterruptEnable();
	min=nows/60; nows%=60;
	h=min/60; min%=60;
	if (days==1)
		putstr(" 1 day ");
	else if (days>1)
	{	print16(days,0);
		putstr(" days ");
	}
	print16(h,2); putchar(':'); 
	print16(min,2); putchar(':');
	print16(nows,2);
	// putchar('.');
	//print16(s100,2);
}
#endif

void init_time(void)
{
	TMR1_SetInterruptHandler(time_irq);
	TMR1_StartTimer();
}
